library("rgp")

myDivide <- function(a,b){if (b==0) return(a) else return (a/b)}

setNonterminals <- functionSet("+", "*", "-","myDivide","sin","cos")

setVariables <- inputVariableSet("x")

setConstants <- constantFactorySet(function() rnorm(1))

eps <- 0.1

dateX <- seq(from = -pi/2+eps, to = pi/2-eps, by = 0.1)

fitness <- function(f) rmse(f(dateX), tan(dateX))


set.seed(1)
gpResult <- 
geneticProgramming(functionSet = setNonterminals,inputVariables = setVariables,constantSet = setConstants,
                   fitnessFunction = fitness,stopCondition = makeStepsStopCondition(1000))

bestSolution1 <- gpResult$population[[which.min(gpResult$fitnessValues)]]

plot(y = bestSolution1(dateX), x = dateX, type = "l",lty = 1, xlab = "x", ylab = "y")

lines(y = tan(dateX), x = dateX, lty = 2, col="red")